<section>
  <h3>Iterations</h3>
  <ng-container *ngIf="(iterations$ | async) as iterations; else noIterations">
    <ng-container *ngIf="iterations.length; else noIterations">
      <table mat-table [dataSource]="iterations">
        <ng-container matColumnDef="numberOfIteration">
          <th mat-header-cell *matHeaderCellDef> № </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.numberOfIteration}} </td>
        </ng-container>

        <ng-container matColumnDef="populationReal">
          <th mat-header-cell *matHeaderCellDef> Population (real numbers) </th>
          <td mat-cell *matCellDef="let iteration">
            {{iteration.population.group | numericVectorsFormatting: '1.1-3' | stringFormatting}}
          </td>
        </ng-container>

        <ng-container matColumnDef="populationBinary">
          <th mat-header-cell *matHeaderCellDef> Population (binary) </th>
          <td mat-cell *matCellDef="let iteration">
            {{iteration.population.binaryGroup | stringFormatting}}
          </td>
        </ng-container>

        <ng-container matColumnDef="stage">
          <th mat-header-cell *matHeaderCellDef> Stage </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.stage }} </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      </table>
    </ng-container>
  </ng-container>
  <ng-template #noIterations>
    <p>No iterations yet</p>
  </ng-template>
</section>

<section>
  <h3>Result</h3>
  <ng-container *ngIf="result">
    <p>Population: {{result.population.group | numericVectorsFormatting: '1.1-3' | stringFormatting}}</p>
    <p>Chosen point: {{result.finalPoint | numberFormatting: '1.1-3'}}</p>
    <p>Function value: {{result.functionValue | numberFormatting: '1.1-3'}}</p>
  </ng-container>
  <ng-container *ngIf="error">
    <p>Error: {{error.message}}</p>
  </ng-container>
  <ng-container *ngIf="!result && !error">
    <p>No result yet</p>
  </ng-container>
</section>

